{$A+,B-,E-,F-,G-,I-,N-,O-,V-,X+ }

{$IFDEF DEBUG }
  {$R+,S+ }
{$ELSE }
  {$D-,L-,R-,S- }
{$ENDIF }

{$M 16384,32768,131072 }

{$IFDEF GDIET }
Program GDieT;
{$ELSE }
Program VDieT;
{$ENDIF }

Uses Dos,VDTDisp,EmulM2,RamDisk2;

Const
      {$IFDEF GDIET }
      SoftName      = 'GDieT';
      {$ELSE }
      SoftName      = 'VDieT';
      {$ENDIF }

      VDCfg : VDispCfg = (
          CSI          : FALSE;   { Optimise deplacement avec CSI }
          OptInvGrp    : TRUE;    { Optimise si invisible }
          {$IFDEF GDIET }
          GXor         : TRUE;
          {$ELSE }
          GXor         : FALSE;
          {$ENDIF }
          OptInvTxt    : TRUE;    { Optimise si invisible }
          OptRepet     : TRUE;    { Optimise si repetition }
          xRep         : FALSE;   { fait toujours prcder le car  repeter }
          ComplAsSpace : FALSE;   { Les complements sont des espaces }
          ForceDelGrp  : FALSE;   { Force ecriture du delimiteur graphik }
          ForceDelTxt  : FALSE;   { Force ecriture du delimiteur texte }
          VideAsSpace  : FALSE;   { ignore les places vides }
          OptWithCan   : TRUE;    { optimise avec le code CAN }
          OptSpclGrp   : TRUE;    { optimisation special avec code #14 }
          OptSpclTxt   : TRUE;    { op avec le code #15 }
          C15Clr       : FALSE;   { #15 n'annule pas le soulignement latent }
          OptMem       : OM_Nothing;
          DebCursor    : FALSE;
          OptNilDRCS   : TRUE;
          NoCR         : FALSE;
          Scroll       : FALSE
        );

Var ScrollDetect : Boolean;
    ScrollWarn   : Boolean;


Var E : EmulRec;
    SaveProc, SaveUp : Pointer;

Var VD : VDispRec;
    VRam : PVDispRam;
    fdest : RamFile;

    NbFileErr : Word;
    NbFileRead : Word;
    NbFileOpt : Word;
    FileExSize : Longint;
    FileNewSize : Longint;

Type ModRec = Record
       x, y, lg, ht : Byte;
      End;

Const MaxMod = 2048;

Var TabMod : Array[0..MaxMod-1] Of ModRec;
    NbMod : Word;
    iRead : Word;
    iWrite : Word;
    CalcOverflow : Boolean;
    DRCSDetect : Boolean;

Procedure PushModRam( x, y, lg, ht : Byte );
Begin
 If NbMod<MaxMod Then
  Begin
   TabMod[iWrite].x := x;
   TabMod[iWrite].y := y;
   TabMod[iWrite].lg := lg;
   TabMod[iWrite].ht := ht;
   Inc(NbMod);
   Inc(iWrite);
   If iWrite>=MaxMod Then iWrite := 0;
  End
 Else CalcOverflow := TRUE;
End;


Function PopModRam( Var x : Byte; Var y : Byte; Var lg : Byte; Var ht : Byte ) : Boolean;
Begin
 If NbMod>0 Then
  Begin

   x := TabMod[iRead].x;
   y := TabMod[iRead].y;
   lg := TabMod[iRead].lg;
   ht := TabMod[iRead].ht;

   Inc(iRead);
   If iRead>=MaxMod Then iRead := 0;

   Dec(NbMod);

   PopModRam := TRUE;
  End
 Else PopModRam := FALSE;
End;


Procedure WriteDest( s : String );
Begin
 If s<>'' Then fdest.write(s);
End;

Procedure Gopt;
Var iY, iX : Byte;
    s : String;
    c : Char;
    a : Word;
    x, y, lg, ht : Byte;
Begin
 While PopModRam(x,y,lg,ht) Do
  Begin
   For iY := Y To Y+Ht-1 Do
    For iX := X To X+Lg-1 Do
     Begin
      c := E.Ram^[iY,iX].Car;
      a := E.Ram^[iY,iX].Att;
      If (c<>#0) And (a And DRCS<>0) Then DRCSDetect := TRUE;
      TransCode(VD,iX,iY,c,a,s);
      WriteDest(s);
     End;
  End;
End;

Procedure FlushVdt;
Var s : String;
Begin
 FlushTrans(VD,s);
 WriteDest(s);
End;


Procedure EmulToScreen( Ram : PVDispRam; x, y, lg, ht : Byte ); Far;
Var iX, iY : Byte;
    c : Char;
    a : Word;
Begin
 If (Ram=E.Ram) Then PushModRam(x,y,lg,ht);
End;


Procedure EmulToScreenScroll( Ram : PVDispRam; y : Byte; Down : Boolean ); Far;
Begin
 If Down Then
  Begin
   ScrollWarn := TRUE;
   ScrollDetect := TRUE;
   EmulToScreen(Ram,0,y,ScreenLong,1);
  End
 Else
  Begin
   ScrollWarn := TRUE;
   ScrollDetect := TRUE;
   EmulToScreen(Ram,0,ScreenHigh-1,ScreenLong,1);
  End;
End;


Var lseq : Array[1..2048] Of Char;
    lgseq : Word;

Procedure WriteSeqDest;
Var s : String;
    i : Word;
Begin
 s := '';
 For i := 1 To lgseq Do
  Begin
   Inc(s[0]);
   s[length(s)] := lseq[i];

   If Length(s)=255 Then
    Begin
     WriteDest(s);
     s := '';
    End;
  End;

 WriteDest(s);
End;

Procedure Optimize( Var E : EmulRec; c : Char );
Var re : Word;
    x, y : Byte;
Begin
 If lgseq<SizeOf(lseq) Then
  Begin
   Inc(lgseq);
   lseq[lgseq] := c;
  End
 Else CalcOverflow := TRUE;

 re := Emul(E,c);

 If ScrollDetect Then
  Begin
   FlushVdt;
   If E.Aig=NUL Then
    Begin
     WriteSeqDest;
     ScrollDetect := FALSE;
     VD.Ram^ := E.Ram^;    { transfert ! hu! }
     VD.Cur.X := E.Situ.X;
     VD.Cur.Y := E.Situ.Y;
     VD.Cur.Att := E.Situ.Att;
     VD.Cur.Rdy := TRUE;

     iRead := 0;
     iWrite := 0;
     NbMod := 0;
    End;
  End
 Else Gopt;

 If (E.Aig=NUL) Then
  Begin
   If re<>EMOP_NIL Then
    Begin
     FlushVdt;
     WriteSeqDest;
     If re=EMOP_ROLLON Then
      Begin
       VD.Cfg.Scroll := TRUE;
      End
     Else
      If (re=EMOP_ROLLOFF) or (re=EMOP_RESET) Then
       Begin
        VD.Cfg.Scroll := FALSE;
       End;
    End
   Else
    Begin
     If c=#12 Then
      Begin
       FlushVdt;

       for y := 1 to ScreenHigh-1 do
        Begin
         for x := 0 to ScreenLong-1 do VRam^[y,x] := Vierge;
        End;
       VD.Cur.X := 0;
       VD.Cur.Y := 1;
       VD.Cur.Att := Trait+Stable;
       VD.Cur.Rdy := TRUE;

       WriteDest(#12);
      End;
     lgseq := 0;
    End;
  End;
End;


const ECfg : EmulCfg = (
          EmulTrans     : TRUE;    { Emulation des transparences }
          VisuelConvert : TRUE;    { Conversion visuelle pour pc }
          RTIC          : TRUE;    { M1B de type RTIC ?          }
          InsLowOnly    : FALSE;   { car M1B                     }
          C15Clr        : FALSE    { car emulateur M1B ...       }
        );




Procedure OptFile( Name : String );
Var f : File;
    buf : Array[1..1024] Of Char;
    lgbuf : Word;
    i : Word;
    exsize, newsize : longint;
    diff : longint;
    err : word;
    final : File;
    s : String;
    r : Word;
Begin
 ClearRam(E.Ram);
 ClearRamDRCS(E.DRCS);
 ClearRam(VRam);

 Assign(f,Name);
 Reset(f,1);
 err := IoResult;
 If err<>0 Then
  Begin
   Inc(NbFileErr);
   If err=2 Then Writeln('*** Fichier non trouv !')
   Else Writeln('*** Erreur sur le fichier!');
  End
 Else
  Begin
   fdest.init;

   Inc(NbFileRead);

   exsize := FileSize(f);
   Write(' ',Name,' (',exsize,'c) ... ');
   InitVD(VD,VRam,NIL,NIL);
   VD.Cfg := VDCfg;

   InitEmul(E,E.Ram,E.DRCS);
   E.Cfg := ECfg;

   NbMod := 0;
   iRead := 0;
   iWrite := 0;
   CalcOverflow := FALSE;
   ScrollWarn := FALSE;
   ScrollDetect := FALSE;
   DRCSDetect := FALSE;

   lgseq := 0;

   While Not(Eof(f)) Do
    Begin
     BlockRead(f,Buf,SizeOf(Buf),lgbuf);
     For i := 1 To lgbuf Do Optimize(E,Buf[i]);
    End;

   FlushVdt;

   newsize := fdest.size;

   Close(f);

   If CalcOverflow Then
    Begin
     Writeln('  BOGUE   !!!');
     Inc(NbFileErr);
    End
   Else
    If DRCSDetect Then
     Begin
      Writeln('  DRCS   !!!');
      Inc(NbFileErr);
     End
    Else
     Begin
      If ScrollWarn Then Write('(SCROLL!) ');

      diff := exsize-newsize;

      If diff<=0 Then
       Begin
        Writeln('Dj trs optimise.  (',-diff,')');
       End
      Else
       Begin
        Inc(NbFileOpt);
        Inc(FileExSize,exsize);
        Inc(FileNewSize,newsize);

        Writeln('-',diff,'c  (reste:',newsize,
                'c)  (-',(diff*100) div exsize,'%)  (-',diff/120:0:1,'s)');

        Assign(final,SoftName+'.BAK');
        Erase(final);
        err := IoResult;

        Rename(f,SoftName+'.BAK');
        err := IoResult;
        If err=0 Then
         Begin
          Assign(f,Name);
          ReWrite(f,1);
          err := IoResult;
          if err=0 Then
           Begin
            fdest.resetget;
            While TRUE Do
             Begin
              fdest.read(s[1],SizeOf(s)-1,r);
              s[0] := char(r);
              If s<>'' Then BlockWrite(f,s[1],length(s))
              Else Break;
             End;
            Close(f);
           End;
         End;
        If err<>0 Then
         Begin
          Writeln('*** Erreur disque!');
          Inc(NbFileErr);
         End;

       End;
     End;

   fdest.done;
  End;

End;

Const MaxName = 512;
Var TabName : Array[1..MaxName] Of PathStr;
    NbName : Word;

Procedure AddFileName( Name : String );
Var i : Word;
Begin
 If NbName<MaxName Then
  Begin
   For i := 1 To NbName Do
    If TabName[i]=Name Then Exit;
   Inc(NbName);
   TabName[NbName] := Name;
  End;
End;

Var DirInfo : SearchRec;
    npar : Word;
    diff : Longint;
    rep  : DirStr;
    n    : NameStr;
    ext  : ExtStr;
    i    : Word;
Begin
 Writeln(SoftName+'  1.0  T.Jaouen  Copyright 1993 (C) T.Jaouen/Fermic Ed.');
 If ParamCount=0 Then
  Begin
   Writeln('Optimiseur de fichier videotex.');
   Writeln('Usage: '+SoftName+' nomfichier.ext');
   Writeln('    ou '+SoftName+' *.pag *.vdt my*.* etc..');
   Writeln(' Note: - les fichiers ne doivent pas contenir de DRCS');
   Writeln('       - les modes "rouleau" (SCROLL) ne sont pas trs optimiss');
   {$IFDEF GDIET }
   Writeln('       - les mlanges graphismes et textes sont dangereux !');
   {$ENDIF }
   Halt(0);
  End
 Else
  Begin

   SaveProc := RamProc.Ptr;
   RamProc.Proc := EmulToScreen;

   SaveUp := ScrollProc.Ptr;
   ScrollProc.Proc := EmulToScreenScroll;

   New(E.Ram);
   New(E.DRCS);

   new(VRam);

   NbFileErr := 0;
   NbFileRead := 0;
   NbFileOpt := 0;
   FileExSize := 0;
   FileNewSize := 0;

   NbName := 0;

   For npar := 1 To ParamCount Do
    Begin
     FindFirst(ParamStr(npar),Archive,DirInfo);
     FSplit(ParamStr(npar),rep,n,ext);
     For i := 1 To Length(rep) Do rep[i] := UpCase(rep[i]);

     While DosError=0 Do
      Begin
       AddFileName(rep+DirInfo.Name);
       FindNext(DirInfo);
      End;
     If (DosError<>18) And (DosError<>0) Then
      Begin
       Writeln('*** Erreur DOS n ',DOSError);
       Break;
      End;
    End;

   If NbName>=MaxName Then
    Begin
     Inc(NbFileErr);
     Writeln('*** Trop de fichiers  traiter !');
    End;

   For npar := 1 To NbName Do OptFile(TabName[npar]);

   If NbFileRead>1 Then Writeln;

   If NbFileErr>0 Then
    Begin
     Writeln('*** Il y a ',NbFileErr,' erreur(s) !');
    End;

   If NbFileRead=0 Then Writeln('    '+SoftName+' n''a analys aucun fichier !')
   Else
    If NbFileRead>1 Then
     Begin
      Writeln('    ',NbFileRead,' fichiers analyss.');
      diff := FileExSIze-FileNewSize;
      If (diff>0) Then
       Begin
        Writeln('    '+SoftName+' a otpimis ',NbFileOpt,' fichiers, -',diff,' caractres  (-',
                (diff*100) div FileExSize,'%) (-',diff/120:0:1,'s)');
       End;
     End;
   ScrollProc.Ptr := SaveUp;
   RamProc.Ptr := SaveProc;

  End;
End.
